from tortoise.exceptions import ValidationError

from ..base import BaseController
from .services import ProductService
from exceptions import common as common_exc, http as http_exc


class ProductController(BaseController):
    product_service = ProductService()

    async def create(self, **kwargs):
        try:
            return await self.product_service.create_product(**kwargs)
        except common_exc.CreateException as e:
            raise http_exc.HTTPBadRequestException(detail=str(e))

        except ValidationError as e:
            raise http_exc.HTTPBadRequestException(detail=f"Validation error: {str(e)}")

    async def get_list(self, **kwargs):
        return await self.product_service.get_product_list(**kwargs)
