import os

from fastapi import FastAPI
from tortoise.contrib.fastapi import register_tortoise


TORTOISE_ORM = {
    'connections': {'default': os.environ.get('DATABASE_URL')},
    'apps': {
        'models': {
            'models': ['src.app.db.models', 'aerich.models'],
            'default_connection': 'default',
        },
    },
}


def init_db(app: FastAPI) -> None:
    register_tortoise(
        app,
        db_url=os.environ.get('DATABASE_URL'),
        modules={"models": ["db.models"]},
        generate_schemas=False,
        add_exception_handlers=True,
    )
